## gnudatalanguage 0.9.5

=== CMakeLists.txt ===
#
# copyright : (c) 2010 Maxime Lenoir and Alain Coulais
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#

# tested with 2.4 and doesn't seem to run.
# SA: 2.6 supports simplified if constructs, e.g. endif()
cmake_minimum_required(VERSION 2.6 FATAL_ERROR)

project(GDL)

# X.X.X CVS becomes release X.X.X+1
set(VERSION "0.9.5")
enable_testing()

include(CheckIncludeFile)
include(CheckIncludeFileCXX)
include(CheckLibraryExists)
include(CheckFunctionExists)
include(CheckSymbolExists)
include(CheckCSourceRuns)
include(CheckCXXSourceCompiles)
include(FindPkgConfig)
include(FindPackageHandleStandardArgs)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/CMakeModules)

#### Default cached values
set(PYTHON_MODULE OFF CACHE BOOL "GDL: Build GDL as a Python module ?")

if(WIN32 AND NOT CYGWIN)
	set(X11 OFF CACHE BOOL "GDL: Enable X11 ?") 
else(WIN32 AND NOT CYGWIN)
	set(X11 ON CACHE BOOL "GDL: Enable X11 ?") 
endif(WIN32 AND NOT CYGWIN)
set(X11DIR "" CACHE PATH "GDL: Specify X11 directory tree")

set(READLINE ON CACHE BOOL "GDL: Enable GNU Readline ?")
set(READLINEDIR "" CACHE PATH "GDL: Specify the GNU readline directory tree")

set(OLDPLPLOT OFF CACHE BOOL "GDL: Enable old plplot ?")
set(PLPLOTDIR "" CACHE PATH "GDL: Specify the plplot directory tree")

set(GSLDIR "" CACHE PATH "GDL: Specify the GSL directory tree")

set(ZLIBDIR "" CACHE PATH "GDL: Specify the Zlib directory tree")

set(WXWIDGETS ON CACHE BOOL "GDL: Enable WxWidgets ?")
set(WXWIDGETSDIR "" CACHE PATH "GDL: Specify WxWidgets directory tree")

set(UDUNITS OFF CACHE BOOL "GDL: Enable UDUNITS-2 ?")
set(UDUNITSDIR "" CACHE PATH "GDL: Specify the UDUNITS-2 directory tree")

set(EIGEN3 ON CACHE BOOL "GDL: Enable Eigen3 ?")
set(EIGEN3DIR "" CACHE PATH "GDL: Specify the Eigen3 directory tree")

set(PSLIB ON CACHE BOOL "GDL: Enable pslib ?")
set(PSLIBDIR "" CACHE PATH "GDL: Specify the pslib directory tree")

set(PNGLIB ON CACHE BOOL "GDL: Enable libpng ?")
set(PNGLIBDIR "" CACHE PATH "GDL: Specify the libpng directory tree")

set(GRIB OFF CACHE BOOL "GDL: Enable Grib ?")
set(GRIBDIR "" CACHE PATH "GDL: Specifiy the GRIB directory tree")


set(MAGICK ON CACHE BOOL "GDL: Enable ImageMagick ?")
set(MAGICKDIR "" CACHE PATH "GDL: Specifiy the ImageMagick directory tree")

# GraphicsMagick is a good alternative to ImageMagick
set(GRAPHICSMAGICK ON CACHE BOOL "GDL: Enable GraphicsMagick ?")
set(GRAPHICSMAGICKDIR "" CACHE PATH "GDL: Specify the GraphicsMagick directory tree")

set(NETCDF ON CACHE BOOL "GDL: Enable NetCDF ?")
set(NETCDFDIR "" CACHE PATH "GDL: Specifiy the netCDF directory tree")

set(HDF ON CACHE BOOL "GDL: Enable Hdf ?")
set(HDFDIR "" CACHE PATH "GDL: Specifiy the HDF directory tree")

set(HDF5 ON CACHE BOOL "GDL: Enable Hdf5 ?")
set(HDF5DIR "" CACHE PATH "GDL: Specifiy the HDF5 directory tree")

set(FFTW ON CACHE BOOL "GDL: Enable FFTW ?")
set(FFTWDIR "" CACHE PATH "GDL: Specifiy the FFTW directory tree")

set(LIBPROJ4 OFF CACHE BOOL "GDL: Enable LIBPROJ4 ?")
set(LIBPROJ4DIR "" CACHE PATH "GDL: Specifiy the LIBPROJ4 directory tree")

set(MPICH OFF CACHE BOOL "GDL: Enable MPICH ?")
set(MPICHDIR "" CACHE PATH "GDL: Specify the MPICH (experimental) directory tree")

set(PYTHON ON CACHE BOOL "GDL: Enable Python ?")
set(PYTHONDIR "" CACHE PATH "GDL: Specifiy the use Python directory tree")
set(PYTHONVERSION "" CACHE STRING "GDL: Specify the Python version to use")

set(GSHHS ON CACHE BOOL "GDL: Enable GSHHS ?")
set(GSHHSDIR "" CACHE PATH "GDL: Specifiy the GSHHS directory tree")

set(NCURSESDIR "" CACHE PATH "GDL: Specify the ncurses (or curses) directory tree")

set(OPENMP ON CACHE BOOL "GDL: Enable OpenMP ?")

# Third party libraries
set(JASPERDIR "" CACHE PATH "GDL: Specify the JasPer directory tree")
set(JPEGDIR "" CACHE PATH "GDL: Specify the JPEG directory tree")
set(SZIPDIR "" CACHE PATH "GDL: Specify the SZip directory tree")

set(GDL_DATA_DIR "/share/gnudatalanguage" CACHE PATH "GDL: data directory relative to CMAKE_INSTALL_PREFIX")


# check for 64-bit OS
if(${CMAKE_SIZEOF_VOID_P} EQUAL 8)
	set(HAVE_64BIT_OS 1)
endif(${CMAKE_SIZEOF_VOID_P} EQUAL 8)


#### check headers and libraries

# dl
check_library_exists(dl dlopen "" HAVE_DL)
if(HAVE_DL)
	set(LIBRARIES ${LIBRARIES} dl)
endif(HAVE_DL)

# malloc stats
check_function_exists(malloc_zone_statistics HAVE_MALLOC_ZONE_STATISTICS)
check_function_exists(sbrk HAVE_SBRK)
check_function_exists(mallinfo HAVE_MALLINFO)

# mallocs
check_include_file(malloc.h HAVE_MALLOC_H)
check_include_file(malloc/malloc.h HAVE_MALLOC_MALLOC_H)

# locale
check_include_file(locale.h HAVE_LOCALE_H)

# std includes..
check_include_file(stdint.h HAVE_STDINT_H)
check_include_file(stdlib.h HAVE_STDLIB_H)
check_include_file(string.h HAVE_STRING_H)
check_include_file(strings.h HAVE_STRINGS_H)
check_include_file(sys/stat.h HAVE_SYS_STAT_H)
check_include_file(sys/types.h HAVE_SYS_TYPES_H)
check_include_file(unistd.h HAVE_UNISTD_H)
#check_include_file(ext/stdio_filebuf.h HAVE_EXT_STDIO_FILEBUF_H)
#sometimes it compiles but stdio_filebuf is only in gcc-x-y-z directory tree...
# would be silly not to use this functionality if present, so recheck:
if (HAVE_EXT_STDIO_FILEBUF_H)
else (HAVE_EXT_STDIO_FILEBUF_H)
	check_cxx_source_compiles("
#include <ext/stdio_filebuf.h>
int main(int argc, char **argv) {
    int i=0;
    i+=1;
}" REALLY_HAVE_EXT_STDIO_FILEBUF_H)
endif (HAVE_EXT_STDIO_FILEBUF_H)
if (REALLY_HAVE_EXT_STDIO_FILEBUF_H)
message(STATUS "INFO: will use GNU extensions for STDIO (useful for compressed I/O) since it seems accepted by your c++ compiler.")
set (HAVE_EXT_STDIO_FILEBUF_H 1)
endif (REALLY_HAVE_EXT_STDIO_FILEBUF_H)
# dlfcn.h
check_include_file(dlfcn.h HAVE_DLFCN_H)

# inttypes.h
check_include_file(inttypes.h HAVE_INTTYPES_H)

# nexttoward
check_library_exists(m nexttoward "" HAVE_NEXTTOWARD)

# mpi
check_include_file(mpi.h HAVE_MPI_H)

# SA: whithout it compilation of antlr fails if there's a conflicting 
#     version of antlr in system-wide directories
include_directories(src)

if(WIN32 AND NOT CYGWIN)
	# For Win32 find Pdcureses instead of (N)Curses
	# -DPDCURSESDIR=DIR
	set(CMAKE_PREFIX_PATH ${PDCURSESDIR})
	find_package(Pdcurses)
	if(PDCURSES_FOUND)
		set(LIBRARIES ${LIBRARIES} ${PDCURSES_LIBRARIES})
		include_directories(${PDCURSES_INCLUDE_DIR})
		set(HAVE_LIBPDCURSES 1)
	else(PDCURSES_FOUND)
		message("${PDCURSES_LIBRARIES}\n${PDCURSES_LIBRARY}\n${PDCURSES_INCLUDE_DIR}\n")
		message(FATAL_ERROR "PDCurses was not found.\n"
			"Use -DPDCURSESDIR=DIR to specify the curses directory tree.\n")
	endif(PDCURSES_FOUND)
else(WIN32 AND NOT CYGWIN)
	# Ncurses MANDATORY
	# -DNCURSESDIR=DIR
	set(CMAKE_PREFIX_PATH ${NCURSESDIR})	
	set(CURSES_NEED_NCURSES TRUE)
	find_package(Curses QUIET COMPONENTS initscr)
	mark_as_advanced(CURSES_CURSES_H_PATH CURSES_FORM_LIBRARY CURSES_HAVE_CURSES_H)
	if(CURSES_FOUND)
		set(HAVE_LIBNCURSES 1)
		set(LIBRARIES ${LIBRARIES} ${CURSES_LIBRARIES})
		include_directories(${CURSES_INCLUDE_DIR})
	else(CURSES_FOUND)
		# search for curses
		set(CURSES_NEED_NCURSES FALSE)
		find_package(Curses COMPONENTS initscr)
		set(HAVE_LIBCURSES ${CURSES_FOUND})
		if(CURSES_FOUND)
			set(LIBRARIES ${LIBRARIES} ${CURSES_LIBRARIES})
			include_directories(${CURSES_INCLUDE_DIR})
		else(CURSES_FOUND)
			message(FATAL_ERROR "(N)Curses was not found.\n"
				"Use -DNCURSESDIR=DIR to specify the curses directory tree.\n"
				"(suitable Debian/Ubuntu package: libncurses-dev)\n")
		endif(CURSES_FOUND)
	endif(CURSES_FOUND)
endif(WIN32 AND NOT CYGWIN)

# Readline
# -DREADLINE=ON|OFF
# -DREADLINEDIR=DIR
if(READLINE)
	# readline needs (n)curses
	set(CMAKE_PREFIX_PATH ${READLINEDIR})
	find_package(Readline QUIET)
	set(HAVE_LIBREADLINE ${READLINE_FOUND})
	if(READLINE_FOUND)
		set(CMAKE_REQUIRED_LIBRARIES ${CURSES_LIBRARIES})
		check_library_exists("${READLINE_LIBRARIES}" rl_get_screen_size "" RL_GET_SCREEN_SIZE)
		if(NOT RL_GET_SCREEN_SIZE)
			message(STATUS "WARNING: Older GNU readline without rl_get_screen_size was found.\n"
			"For resized terminals the size might not be updated correctly.\n"
			"If this is a problem please install a recent version of readline.")
		endif(NOT RL_GET_SCREEN_SIZE)
		set(LIBRARIES ${LIBRARIES} ${READLINE_LIBRARIES})
		include_directories(${READLINE_INCLUDE_DIR})
		set(CMAKE_REQUIRED_LIBRARIES)
	else(READLINE_FOUND)
		message(FATAL_ERROR "GNU readline was not found.\n"
		  "Use -DREADLINEDIR=no to explicitely disable it.\n"
                  "(suitable Debian/Ubuntu package: libreadline-gplv2-dev)\n"
                  "(suitable Fedora package: readline-devel)")
	endif(READLINE_FOUND)
endif(READLINE)

# zlib MANDATORY
# -DZLIBDIR=DIR
set(CMAKE_PREFIX_PATH ${ZLIBDIR})
find_package(ZLIB QUIET)
set(HAVE_LIBZ ${ZLIB_FOUND})
if(ZLIB_FOUND)
	set(LIBRARIES ${LIBRARIES} ${ZLIB_LIBRARIES})
	include_directories(${ZLIB_INCLUDE_DIR})
else(ZLIB_FOUND)
	message(FATAL_ERROR "ZLib library is required but was not found.\n"
	"Use -DZLIBDIR=DIR to specify the zlib directory tree.\n"
        "(suitable Debian/Ubuntu package: zlib1g-dev)\n"
        "(suitable Fedora package: zlib-devel)")
endif(ZLIB_FOUND)

# libpng
# -DPNGLIB=ON|OFF
# -DPNGLIBDIR=DIR
if(PNGLIB)
	set(CMAKE_PREFIX_PATH ${PNGLIBDIR})
	find_package(PNG QUIET)
	set(USE_PNGLIB ${PNG_FOUND})
	if(PNG_FOUND)
		set(LIBRARIES ${LIBRARIES} ${PNG_LIBRARIES})
		set(LINK_DIRECTORIES ${LINK_DIRECTORIES} ${PNG_LIBRARY_DIRS})
		include_directories(${PNG_INCLUDE_DIRS})
	else(PNG_FOUND)
		message(FATAL_ERROR "libpng is required but was not found.\n"
		"Use -DPNGLIBDIR=DIR to specify the libpng directory tree.\n"
		"Use -DPNGLIB=OFF to not use it.\n"
                "(suitable Debian/Ubuntu package: libpng-dev)\n"
                "(suitable Fedora package: libpng-devel)")
	endif(PNG_FOUND)
endif(PNGLIB)

# openmp
# -DOPENMP=ON|OFF
if(OPENMP)
	find_package(OpenMP QUIET)
	if(OPENMP_FOUND)
		add_definitions(${OpenMP_CXX_FLAGS})
		if(WIN32 AND NOT CYGWIN)
			set(LIBRARIES ${LIBRARIES} vcomp)
		else(WIN32 AND NOT CYGWIN)
			set(LIBRARIES ${LIBRARIES} ${OpenMP_CXX_FLAGS})
		endif(WIN32 AND NOT CYGWIN)
	endif(OPENMP_FOUND)
else(OPENMP)
  # we need to define those semaphore posix symbols, do it with threads libs
  find_package(Threads)
  if(THREADS_FOUND)
    set(LIBRARIES ${LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
  else(THREADS_FOUND)
    check_library_exists(rt sem_unlink "" HAVE_RT)
    if(HAVE_RT)
      set(LIBRARIES ${LIBRARIES} rt)
    else(HAVE_RT)
      message(FATAL_ERROR "Missing a POSIX semaphore symbols (rt or threads).\n")
    endif(HAVE_RT)
  endif(THREADS_FOUND)
endif(OPENMP)

# GSL MANDATORY
# -DGSLDIR=DIR
set(CMAKE_PREFIX_PATH ${GSLDIR})
find_package(GSL QUIET)
set(HAVE_LIBGSL ${GSL_FOUND})
set(HAVE_LIBGSLCBLAS ${GSL_FOUND})
if(GSL_FOUND)
	set(LIBRARIES ${LIBRARIES} ${GSL_LIBRARIES})
	include_directories(${GSL_INCLUDE_DIR})
else(GSL_FOUND)
	message(FATAL_ERROR "Gnu Scientific library (1.7 or higher) and libgslcblas are mandatory.\n"
	"Use -DGSLDIR=DIR to specify the gsl directory tree.\n"
        "(suitable Debian/Ubuntu package: libgsl0-dev)\n"
        "(suitable Fedora package: gsl-devel)")
endif(GSL_FOUND)

if(WIN32 AND NOT CYGWIN)
set(CMAKE_PREFIX_PATH ${XDRDIR})
find_package(xdr)
set(HAVE_LIBXDR ${XDR_FOUND})
if(XDR_FOUND)
	set(LIBRARIES ${LIBRARIES} ${XDR_LIBRARIES})
	include_directories(${XDR_INCLUDE_DIR})
else(XDR_FOUND)
	message(FATAL_ERROR "bsd-xdr library is required but was not found.\n"
	"Use -DXDRDIR=DIR to specify the bsd-xdr directory tree.")
endif(XDR_FOUND)

set(CMAKE_PREFIX_PATH ${PCREDIR})
find_package(pcre)
set(HAVE_LIBPCRE ${PCRE_FOUND})
if(PCRE_FOUND)
	set(LIBRARIES ${LIBRARIES} ${PCRE_LIBRARIES})
	include_directories(${PCRE_INCLUDE_DIR})
else(PCRE_FOUND)
	message(FATAL_ERROR "pcre library is required but was not found.\n"
	"Use -DPCREDIR=DIR to specify the pcre directory tree.")

=== src/CMakeLists.txt ===
set(SOURCES
CFMTLexer.cpp
CFMTLexer.hpp
CFMTTokenTypes.hpp
FMTIn.cpp
FMTIn.hpp
FMTInTokenTypes.hpp
FMTLexer.cpp
FMTLexer.hpp
FMTOut.cpp
FMTOut.hpp
FMTOutTokenTypes.hpp
FMTParser.cpp
FMTParser.hpp
FMTTokenTypes.hpp
GDLInterpreter.cpp
GDLInterpreter.hpp
GDLInterpreterTokenTypes.hpp
GDLLexer.cpp
GDLLexer.hpp
GDLParser.cpp
GDLParser.hpp
GDLTokenTypes.hpp
GDLTreeParser.cpp
GDLTreeParser.hpp
GDLTreeParserTokenTypes.hpp
accessdesc.hpp
allix.hpp
allix.cpp
arrayindex.cpp
arrayindex.hpp
arrayindexlistt.hpp
arrayindexlistnoassoct.hpp
assocdata.cpp
assocdata.hpp
basegdl.cpp
basegdl.hpp
basic_fun.cpp
basic_fun.hpp
basic_fun_cl.cpp
basic_fun_cl.hpp
basic_fun_jmg.cpp
basic_fun_jmg.hpp
basic_op.cpp
cformat.g
color.cpp
color.hpp
convert2.cpp
convol.cpp
convol_inc0.cpp
convol_inc1.cpp
convol_inc2.cpp
datalistt.hpp
datatypes.cpp
datatypes.hpp
datatypesref.cpp
dcommon.cpp
dcommon.hpp
dcompiler.cpp
dcompiler.hpp
default_io.cpp
deviceps.hpp
devicesvg.hpp
devicez.hpp
dimension.hpp
dinterpreter.cpp
dinterpreter.hpp
dnode.cpp
dnode.hpp
dnodefactory.hpp
dpro.cpp
dpro.hpp
dstructdesc.cpp
dstructdesc.hpp
dstructgdl.cpp
dstructgdl.hpp
dvar.cpp
dvar.hpp
envt.cpp
envt.hpp
extrat.cpp
extrat.hpp
fftw.cpp
fftw.hpp
file.cpp
file.hpp
fmtnode.cpp
fmtnode.hpp
format.g
format.in.g
format.out.g
gdlc.g
gdlc.i.g
gdlc.tree.g
gdleventhandler.cpp
gdleventhandler.hpp
gdlexception.cpp
gdlexception.hpp
gdlgstream.cpp
gdlgstream.hpp
)
if(WIN32)
set(SOURCES
${SOURCES}
gdlwinstream.cpp
gdlwinstream.hpp
gtdhelper.cpp
gtdhelper.hpp
devicewin.hpp
devicewin.cpp
)
else(WIN32)
set(SOURCES
${SOURCES}
devicex.hpp
gdlxstream.cpp
gdlxstream.hpp
)
endif(WIN32)
set(SOURCES
${SOURCES}
gdljournal.cpp
gdljournal.hpp
gdlpsstream.cpp
gdlpsstream.hpp
gdlpython.cpp
gdlpython.hpp
gdlsvgstream.cpp
gdlsvgstream.hpp
gdlwidget.cpp
gdlwidgeteventhandler.cpp
gdlwidget.hpp
gdlwidgetdraw.cpp
gdlwxstream.cpp
gdlwxstream.hpp
gdlzstream.cpp
gdlzstream.hpp
getfmtast.cpp
getfmtast.hpp
graphicsdevice.cpp
graphicsdevice.hpp
basic_pro.cpp
basic_pro.hpp
basic_pro_jmg.cpp
basic_pro_jmg.hpp
grib.cpp
grib.hpp
gshhs.cpp
gshhs.hpp
gsl_fun.cpp
gsl_fun.hpp
gsl_matrix.cpp
gsl_matrix.hpp
gzstream.hpp
hash.cpp
hash.hpp
hdf5_fun.cpp
hdf5_fun.hpp
hdf_fun.cpp
hdf_fun.hpp
hdf_pro.cpp
hdf_pro.hpp
ifmt.cpp
image.cpp
image.hpp
initct.cpp
initsysvar.cpp
initsysvar.hpp
io.cpp
io.hpp
lapack.cpp
libinit.cpp
libinit_ac.cpp
libinit_cl.cpp
libinit_gm.cpp
libinit_jmg.cpp
libinit_mes.cpp
libinit_ng.cpp
list.cpp
list.hpp
magick_cl.cpp
magick_cl.hpp
math_fun.cpp
math_fun.hpp
math_fun_ac.cpp
math_fun_ac.hpp
math_fun_gm.cpp
math_fun_gm.hpp
math_fun_jmg.cpp
math_fun_jmg.hpp
math_fun_ng.cpp
math_fun_ng.hpp
math_utl.cpp
math_utl.hpp
matrix_cholesky.cpp
matrix_cholesky.hpp
matrix_invert.cpp
matrix_invert.hpp
mpi.cpp
mpi.hpp
ncdf_att_cl.cpp
ncdf_cl.cpp
ncdf_cl.hpp
ncdf_dim_cl.cpp
ncdf_var_cl.cpp
ncdf4_group.cpp
new.cpp
new.hpp
newprognode.cpp
nullgdl.cpp
nullgdl.hpp
objects.cpp
objects.hpp
ofmt.cpp
ofmt.hpp
overload.cpp
overload.hpp
plotting_axis.cpp
plotting_contour.cpp
plotting_convert_coord.cpp
plotting_cursor.cpp
plotting_device.cpp
plotting_erase.cpp
plotting_image.cpp
plotting_map_proj.cpp
plotting_misc.cpp
plotting_oplot.cpp
plotting_plot.cpp
plotting_plots.cpp
plotting_polyfill.cpp
plotting_shade_surf.cpp
plotting_surface.cpp
plotting_windows.cpp
plotting_xyouts.cpp
plotting.cpp
plotting.hpp
print.cpp
print_tree.cpp
print_tree.hpp
prognode.cpp
prognode_lexpr.cpp
prognodeexpr.cpp
read.cpp
real2int.hpp
semshm.cpp
semshm.hpp
sigfpehandler.cpp
sigfpehandler.hpp
smooth.cpp
smooth.hpp
specializations.hpp
str.cpp
str.hpp
strassenmatrix.hpp
terminfo.cpp
terminfo.hpp
topython.cpp
typedefs.hpp
typetraits.cpp
typetraits.hpp
widget.cpp
widget.hpp
)

add_subdirectory(antlr)

include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/src/antlr ${CMAKE_BINARY_DIR})
link_directories(${LINK_DIRECTORIES})

if(PYTHON_MODULE) #libgdl
	set(SOURCES ${SOURCES} pythongdl.cpp)
	add_library(gdl SHARED ${SOURCES})
else(PYTHON_MODULE) #gdl
	set(SOURCES ${SOURCES} gdl.cpp)
	add_executable(gdl ${SOURCES})
endif(PYTHON_MODULE)

add_dependencies(gdl antlr) # be sure that antlr is built before gdl
target_link_libraries(gdl antlr) # link antlr against gdl
if (MINGW)
target_link_libraries(gdl ws2_32)
endif (MINGW)
target_link_libraries(gdl ${LIBRARIES})
add_definitions(-DHAVE_CONFIG_H)

if(PYTHON_MODULE)
#	TODO: this library should go to Python library path (site-packages?)
#	install(TARGETS gdl DESTINATION ${CMAKE_INSTALL_PREFIX}/lib)
else(PYTHON_MODULE)
	install(TARGETS gdl DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
	set_target_properties(gdl PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)
endif(PYTHON_MODULE)

install(DIRECTORY ${CMAKE_SOURCE_DIR}/src/pro/ DESTINATION ${CMAKE_INSTALL_PREFIX}/${GDL_DATA_DIR}/lib
	PATTERN CVS EXCLUDE
	PATTERN checks EXCLUDE
	PATTERN Makefile* EXCLUDE
	PATTERN UrgentNeed.txt EXCLUDE)

=== testsuite/CMakeLists.txt ===
set(BASE_SOURCE ${CMAKE_SOURCE_DIR})
set(BASE_BINARY ${CMAKE_BINARY_DIR})
# write the test launcher
set(LAUNCH
"#include<unistd.h>
#include<stdlib.h>
#include<stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/wait.h>
#include<sched.h>
int main(int c,char**v) {
char*p;
if(c!=2) return 1;
for(p=v[1];*p;++p);
if(p-4<v[1]) return 1;
if(p[-1]!='o'||p[-2]!='r'||p[-3]!='p'||p[-4]!='.') return 1;
*(p-4)=0;
setenv(\"LC_COLLATE\",\"C\",1);
setenv(\"GDL_PATH\",\"+${BASE_SOURCE}/testsuite/:+${BASE_SOURCE}/src/pro/\",1);
unsetenv(\"GDL_STARTUP\");
unsetenv(\"IDL_STARTUP\");
int devnull = open(\"/dev/null\",O_RDONLY);
dup2(devnull, 0);
int child_pid = fork();
if(child_pid == 0) {
  execl(\"${BASE_BINARY}/src/gdl\",\"-quiet\",\"-e\",v[1],(char*)0);
  exit(1);
} else {
  sched_yield();
  int child_status;
  waitpid(child_pid, &child_status, 0);
  if (WEXITSTATUS(child_status) == 77) {
    printf(\"TEST SKIPPED\");
    exit(0);
  } else if (WIFSIGNALED(child_status)) {
    printf(\"TEST EXITED FROM SIGNAL %d\", WTERMSIG(child_status));
    exit(1);
  } else {
    exit(WEXITSTATUS(child_status));
  }
}
}
")
file(WRITE ${CMAKE_SOURCE_DIR}/testsuite/launchtest.c "${LAUNCH}")
add_executable(launchtest EXCLUDE_FROM_ALL ${CMAKE_SOURCE_DIR}/testsuite/launchtest.c)
add_library(test_ce SHARED EXCLUDE_FROM_ALL libtest_ce.cpp)
add_custom_target(check COMMAND ${CMAKE_BUILD_TOOL} test DEPENDS launchtest test_ce gdl)
get_target_property(LAUNCHTESTLOCATION launchtest LOCATION)
execute_process(
  COMMAND "fgrep" ".pro" "${BASE_SOURCE}/testsuite/Makefile.am" 
  COMMAND "awk" "{printf(\"%s;\",$1)}" 
  OUTPUT_VARIABLE TESTS)
foreach(TEST ${TESTS})
	add_test(${TEST} ${LAUNCHTESTLOCATION} ${TEST})
	set_tests_properties(${TEST} PROPERTIES SKIP_RETURN_CODE 77) # autoconf's setting
endforeach(TEST TESTS)

=== debian/changelog ===
gnudatalanguage (0.9.5-6) unstable; urgency=low

  * arm64 builds fine again, so upload to unstable again.

 -- Axel Beckert <abe@debian.org>  Fri, 11 Dec 2015 18:06:30 +0100

gnudatalanguage (0.9.5-5) experimental; urgency=low

  [ Ole Streicher ]
  * Replace __DATE__ by d/changelog date for reproducible build.

  [ Axel Beckert ]
  * Re-enable arm64 again, restrict libeigen3-dev b-d ≥ 3.3~alpha1-3 on
    arm64 and upload to experimental for now. See #803552 for the
    background about this.

 -- Axel Beckert <abe@debian.org>  Fri, 11 Dec 2015 15:33:28 +0100

gnudatalanguage (0.9.5-4) unstable; urgency=medium

  [ Axel Beckert ]
  * Move gnudatalanguage under the umbrella of the Debian Astronomy Team.
    + Set Maintainer to debian-astro-maintainers@lists.alioth.debian.org
    + Move myself to Uploaders.
    + Remove Gürkan from Uploaders (with his approval).
    + Update Vcs-* headers.
  * Apply wrap-and-sort.
  * Update build-dependency from libgsl0-dev to libgsl-dev for the GSL 2.0
    transition. (Closes: #807203) Thanks Bas Couwenberg!
  * Temporarily remove arm64 from the list of architectures. (See #805532
    and #803552 for details.)

  [ Ole Streicher ]
  * Put me (olebole) to uploaders, as suggested by Axel.

 -- Axel Beckert <abe@debian.org>  Sun, 06 Dec 2015 22:11:38 +0100

gnudatalanguage (0.9.5-3) unstable; urgency=low

  * Install AUTHORS and README to /usr/share/doc/gnudatalanguage/ instead
    of /usr/share/gnudatalanguage/ as done by upstream. (Closes: #790127)

 -- Axel Beckert <abe@debian.org>  Sun, 18 Oct 2015 19:58:41 +0200

gnudatalanguage (0.9.5-2) unstable; urgency=low

  * Upload to unstable

 -- Axel Beckert <abe@debian.org>  Mon, 13 Oct 2014 14:06:22 +0200

gnudatalanguage (0.9.5-1) experimental; urgency=low

  * New upstream release
    + Drop patch wid-vs-width (obsolete)
    + Remove all autotools-related hunks from
      build-with-debian-antlr-instead-embedded-one
    + Refresh patches fix-python-libs-multiarch and fix-spelling-errors
    + Backup testsuite/launchtest.c before building instead of deleting
    + Add patch to disable tests which work fine with local X but hang
      under xvfb-run.
  * Remove patch file disable-plstrl-and-plP_mmpcx, unused since 0.9.3-1
  * Allow compilation against older versions of plplot to ease backports
  * Bump Standards-Version to 3.9.6 (no changes necessary)
  * Add DEP3 patch headers to build-with-debian-antlr-instead-embedded-one
  * Rework debian/copyright
    + Switch to machine-readable DEP5 format
    + Update copyright years
    + Order copyright owners by copyright years
    + Drop copyright listings which are no more present in upstream's code
    + Add missing copyrights

 -- Axel Beckert <abe@debian.org>  Fri, 10 Oct 2014 21:08:44 +0200

gnudatalanguage (0.9.4-3) unstable; urgency=low

  * Use continuation lines to make dh_auto_configure call more patch
    friendly.
  * Patch CMakeLists.txt to make cmake 3 find libpython with multiarch
    paths. Fixes FTBFS with cmake 3. (Closes: #762681)
  * Drop plplot_config.h workaround. Bump versioned build-dependency on
    libplplot-dev to 5.10.0+dfsg-1~ for the fix for #761176.

 -- Axel Beckert <abe@debian.org>  Wed, 24 Sep 2014 15:57:47 +0200

gnudatalanguage (0.9.4-2) unstable; urgency=low

  * Use CMake as build system as recommended by upstream:
    + Fixes builds on kfreebsd and powerpc (Closes: #725957)
    + Enforce cmake as build system in debian/rules.
    + Remove non-cmake workarounds from debian/rules.
    + Add build-dependencies on cmake, libncurses-dev and libeigen-dev.
    + Replace build-dependency on libmagick++-dev by
      libgraphicsmagick++1-dev.
    + Remove build-dependencies on autotools-dev and dh-autoreconf.
    + Expand patch build-with-debian-antlr-instead-embedded-one to cover
      src/CMakeLists.txt.
    + Add some more leftover files to debian/clean.
    + Compile testsuite launcher manually for now.
  * Adapt for plplot 5.10
    + Add patch wid-vs-width, taken from Ubuntu.
    + Copy /usr/include/plplot/*.h to src/plplot/ and modify plConfig.h to
      no more look for the non-existing file plplot_config.h
    + Add version constraint to libplplot-dev build-dependency.
  * Switch wxwidgets build-dependency to libwxgtk3.0-dev (Closes: #751566)
  * Run test suite within a virtual framebuffer display.
    + Add build-dependency on xvfb and xauth.
  * Remove obsolete dh_installchangelog override from debian/rules.
  * Bump Standards-Version to 3.9.5 (no changes).
  * Update Recommends to follow plplot's SONAME bump.
  * Apply wrap-and-sort -a.
  * Use chrpath to strip rpath from built gdl binary.
    + Add build-dependency on chrpath.
    + Fixes lintian warning binary-or-shlib-defines-rpath.
  * Add patch to fix spelling errors found by lintian.
  * Switch Vcs-Browser header to new cgit web interface.
  * Drop architecture checks for GRIB API. It's arch:any again.
  * Update long package description to mention the short form GDL.

 -- Axel Beckert <abe@debian.org>  Wed, 10 Sep 2014 20:50:15 +0200

=== debian/control ===
Source: gnudatalanguage
Maintainer: Debian Astronomy Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Axel Beckert <abe@debian.org>,
           Ole Streicher <olebole@debian.org>
Section: interpreters
Priority: extra
Build-Depends: chrpath,
               cmake,
               debhelper (>= 9~),
               dpkg-dev (>= 1.16.1~),
               libantlr-dev,
               libeigen3-dev,
               libeigen3-dev (>= 3.3~alpha1-3) [arm64],
               libfftw3-dev,
               libgraphicsmagick++1-dev,
               libgrib-api-dev,
               libgsl-dev,
               libhdf4-alt-dev,
               libhdf5-dev | libhdf5-serial-dev,
               libncurses-dev,
               libnetcdf-dev,
               libplplot-dev (>= 5.10.0+dfsg-1~) | libplplot-dev (<= 5.10),
               libreadline-dev,
               libudunits2-dev,
               libwxgtk3.0-dev,
               pslib-dev,
               python-all-dev,
               python-numpy,
               xauth,
               xvfb,
               zlib1g-dev
Standards-Version: 3.9.6
Homepage: http://gnudatalanguage.sourceforge.net/
Vcs-Git: git://anonscm.debian.org/debian-astro/packages/gnudatalanguage.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-astro/packages/gnudatalanguage.git

Package: gnudatalanguage
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: plplot12-driver-xwin,
            python-numpy
Description: Free IDL compatible incremental compiler
 GDL is a free IDL (Interactive Data Language) compatible incremental
 compiler. It has full syntax compatibility with IDL 7.1. IDL is a
 registered trademark of ITT Visual Information Solutions.

=== debian/rules ===
#!/usr/bin/make -f

CXXFLAGS += -DBUILD_DATE="\"$(shell LC_ALL=C date -u --date="`dpkg-parsechangelog -SDate`" +'%b %e %Y')\""

%:
	dh $@ --parallel -Scmake

override_dh_auto_configure:
	# Patched source FTBFS if this embedded code copy is present
	tar cf antlr.tar src/antlr testsuite/launchtest.c
	rm -rf src/antlr

	dh_auto_configure -Scmake -- \
	  -DPYTHONDIR=/usr \
	  -DPYTHONVERSION=2.7 \
	  -DDEB_BUILD_MULTIARCH=`dpkg-architecture -qDEB_BUILD_MULTIARCH` \
	  -DFFTW=YES \
	  -DPYTHON=YES \
	  -DWXWIDGETS=YES \
	  -DGRIB=YES \
	  -DUDUNITS=YES \
	  -DPSLIB=YES

override_dh_auto_install:
	dh_auto_install
	# See https://wiki.debian.org/RpathIssue
	chrpath --delete debian/gnudatalanguage/usr/bin/gdl
	# See #790127
	rm -f debian/gnudatalanguage/usr/share/gnudatalanguage/README \
	      debian/gnudatalanguage/usr/share/gnudatalanguage/AUTHORS

override_dh_auto_test:
	cd obj*/testsuite; $(CC) -o launchtest ../../testsuite/launchtest.c
	-xvfb-run dh_auto_test --parallel -Scmake

override_dh_auto_clean:
	if [ -f  antlr.tar ]; then tar xf antlr.tar; fi
	rm -f antlr.tar
	dh_auto_clean --parallel -Scmake

override_dh_compress:
	dh_compress -X.pro

## gnudatalanguage 0.9.6

=== debian/changelog ===
gnudatalanguage (0.9.6-1) unstable; urgency=low

  [ Ole Streicher ]
  * New upstream release
    + drop patch reproducible_build: applied upstream
    + refresh all other patches
    + require libeigen3-dev >= 3.2.4 for building (except for arm64; see
      below)
    + fix FILE_MOVE
    + Don't save launchtest.c anymore, it was removed from the upstream
      tar ball.
  * Fix FTBFS on GNU HURD
  * Add CI tests
  * Create shared lib package
  * Create Python extension. Closes: #751718
  * Don't run test suite in parallel.

  [ Axel Beckert ]
  * Add testsuite/launchtest.c to debian/clean.
  * Remove File stanzas from debian/copyright which referred to files no
    more shipped in the new upstream release. (Multiple lintian warnings)
  * Update patch fix-spelling-errors for new misspellings found by lintian
  * debian/rules: Remove redundant occurrences of -Scmake.
  * Add lintian override for libgnudatalanguage0's no-symbols-control-file
  * Add epoch in front of python-gdl's version number. Necessary due to a
    different package of that name existed in Squeeze.
  * Finetune package descriptions (mention the phrase "GNU Data Language")

 -- Axel Beckert <abe@debian.org>  Wed, 06 Jan 2016 13:52:09 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
                debhelper (>= 9~),
                dpkg-dev (>= 1.16.1~),
                libantlr-dev,
-               libeigen3-dev,
+               libeigen3-dev (>= 3.2.4),
                libeigen3-dev (>= 3.3~alpha1-3) [arm64],
                libfftw3-dev,
                libgraphicsmagick++1-dev,
@@ -23,6 +23,7 @@
                libreadline-dev,
                libudunits2-dev,
                libwxgtk3.0-dev,
+               plplot12-driver-xwin,
                pslib-dev,
                python-all-dev,
                python-numpy,
@@ -33,6 +34,23 @@
 Homepage: http://gnudatalanguage.sourceforge.net/
 Vcs-Git: git://anonscm.debian.org/debian-astro/packages/gnudatalanguage.git
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-astro/packages/gnudatalanguage.git
+Testsuite: autopkgtest
+
+Package: libgnudatalanguage0
+Architecture: any
+Section: libs
+Depends: ${misc:Depends},
+         ${shlibs:Depends}
+Breaks: gnudatalanguage (<< 0.9.5-7~)
+Replaces: gnudatalanguage (<< 0.9.5-7~)
+Description: Free IDL compatible incremental compiler shared library
+ GNU Data Language (GDL) is a free IDL (Interactive Data Language)
+ compatible incremental compiler. It has full syntax compatibility
+ with IDL 7.1. IDL is a registered trademark of ITT Visual Information
+ Solutions.
+ .
+ This package contains the shared library which is used by the different
+ frontends (gdl binary, Python package).
 
 Package: gnudatalanguage
 Architecture: any
@@ -41,6 +59,43 @@
 Recommends: plplot12-driver-xwin,
             python-numpy
 Description: Free IDL compatible incremental compiler
- GDL is a free IDL (Interactive Data Language) compatible incremental
- compiler. It has full syntax compatibility with IDL 7.1. IDL is a
- registered trademark of ITT Visual Information Solutions.
+ GNU Data Language (GDL) is a free IDL (Interactive Data Language)
+ compatible incremental compiler. It has full syntax compatibility
+ with IDL 7.1. IDL is a registered trademark of ITT Visual Information
+ Solutions. From IDL 8.0, the following language elements are
+ supported:
+ .
+  * FOREACH loop
+  * negative array indices
+  * garbage collection pointers and objects
+  * call methods on an object using "." (e. g. `object.aMemberProcedure,arg1`)
+ .
+ The file input output system is fully implemented. GUI support (widgets) is
+ officially provided, but it's not complete yet.
+ .
+ This package contains the main commandline and interpreter frontend.
+
+Package: python-gdl
+Architecture: any
+Section: python
+Depends: python,
+         python-numpy,
+         ${misc:Depends},
+         ${shlibs:Depends}
+Recommends: plplot12-driver-xwin
+Description: Python interface for the GNU Data Language
+ GNU Data Language (GDL) is a free IDL (Interactive Data Language)
+ compatible incremental compiler. It has full syntax compatibility
+ with IDL 7.1. IDL is a registered trademark of ITT Visual Information
+ Solutions. From IDL 8.0, the following language elements are
+ supported:
+ .
+  * FOREACH loop
+  * negative array indices
+  * garbage collection pointers and objects
+  * call methods on an object using "." (e. g. `object.aMemberProcedure,arg1`)
+ .
+ The file input output system is fully implemented. GUI support (widgets) is
+ officially provided, but it's not complete yet.
+ .
+ This package contains the Python library/interface.

=== debian/rules ===
#!/usr/bin/make -f

CXXFLAGS += -DBUILD_DATE="\"$(shell LC_ALL=C date -u --date="`dpkg-parsechangelog -SDate`" +'%b %e %Y')\""
VERSION=$(shell dpkg-parsechangelog -SVersion)

%:
	dh $@ --parallel -Scmake

override_dh_auto_configure:
	# Patched source FTBFS if this embedded code copy is present
	tar cf antlr.tar src/antlr
	rm -rf src/antlr

	dh_auto_configure -- \
	  -DPYTHONDIR=/usr \
	  -DPYTHONVERSION=2.7 \
	  -DDEB_BUILD_MULTIARCH=`dpkg-architecture -qDEB_BUILD_MULTIARCH` \
	  -DFFTW=YES \
	  -DPYTHON=YES \
	  -DPYTHON_MODULE=YES \
	  -DWXWIDGETS=YES \
	  -DGRIB=YES \
	  -DUDUNITS=YES \
	  -DPSLIB=YES

override_dh_auto_test:
	( cd obj*/testsuite \
	&& cp ../../testsuite/formats.idl . \
	&& $(CXX) -o libtest_ce.so ../../testsuite/libtest_ce.cpp -shared -fPIC \
	&& $(CC) -o launchtest ../../testsuite/launchtest.c )
	LD_LIBRARY_PATH="../src" xvfb-run dh_auto_test --no-parallel -Scmake || true

override_dh_auto_clean:
	if [ -f  antlr.tar ]; then tar xf antlr.tar; fi
	rm -f antlr.tar
	dh_auto_clean --parallel

override_dh_compress:
	dh_compress -X.pro

# The epoch in front of python-gdl's version number is needed since
# Debian Squeeze had a python-gdl binary package with version 2.25.3-7
# built from the gnome-python-extras source package.
override_dh_gencontrol:
	dh_gencontrol -ppython-gdl -- -v1:$(VERSION)
	dh_gencontrol --remaining

## gnudatalanguage 0.9.6v2

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,7 @@
 project(GDL)
 
 # X.X.X CVS becomes release X.X.X+1
-set(VERSION "0.9.5")
+set(VERSION "0.9.6")
 enable_testing()
 
 include(CheckIncludeFile)
@@ -32,11 +32,7 @@
 #### Default cached values
 set(PYTHON_MODULE OFF CACHE BOOL "GDL: Build GDL as a Python module ?")
 
-if(WIN32 AND NOT CYGWIN)
-	set(X11 OFF CACHE BOOL "GDL: Enable X11 ?") 
-else(WIN32 AND NOT CYGWIN)
-	set(X11 ON CACHE BOOL "GDL: Enable X11 ?") 
-endif(WIN32 AND NOT CYGWIN)
+set(X11 ON CACHE BOOL "GDL: Enable X11 ?") 
 set(X11DIR "" CACHE PATH "GDL: Specify X11 directory tree")
 
 set(READLINE ON CACHE BOOL "GDL: Enable GNU Readline ?")
@@ -67,6 +63,8 @@
 set(GRIB OFF CACHE BOOL "GDL: Enable Grib ?")
 set(GRIBDIR "" CACHE PATH "GDL: Specifiy the GRIB directory tree")
 
+set(QHULL OFF CACHE BOOL "GDL: Enable Qhull ?")
+set(QHULLDIR "" CACHE PATH "GDL: Specifiy the QHULL directory tree")
 
 set(MAGICK ON CACHE BOOL "GDL: Enable ImageMagick ?")
 set(MAGICKDIR "" CACHE PATH "GDL: Specifiy the ImageMagick directory tree")
@@ -100,7 +98,9 @@
 set(GSHHS ON CACHE BOOL "GDL: Enable GSHHS ?")
 set(GSHHSDIR "" CACHE PATH "GDL: Specifiy the GSHHS directory tree")
 
-set(NCURSESDIR "" CACHE PATH "GDL: Specify the ncurses (or curses) directory tree")
+if(NOT WIN32)
+  set(NCURSESDIR "" CACHE PATH "GDL: Specify the ncurses (or curses) directory tree")
+endif(NOT WIN32)
 
 set(OPENMP ON CACHE BOOL "GDL: Enable OpenMP ?")
 
@@ -178,22 +178,8 @@
 #     version of antlr in system-wide directories
 include_directories(src)
 
-if(WIN32 AND NOT CYGWIN)
-	# For Win32 find Pdcureses instead of (N)Curses
-	# -DPDCURSESDIR=DIR
-	set(CMAKE_PREFIX_PATH ${PDCURSESDIR})
-	find_package(Pdcurses)
-	if(PDCURSES_FOUND)
-		set(LIBRARIES ${LIBRARIES} ${PDCURSES_LIBRARIES})
-		include_directories(${PDCURSES_INCLUDE_DIR})
-		set(HAVE_LIBPDCURSES 1)
-	else(PDCURSES_FOUND)
-		message("${PDCURSES_LIBRARIES}\n${PDCURSES_LIBRARY}\n${PDCURSES_INCLUDE_DIR}\n")
-		message(FATAL_ERROR "PDCurses was not found.\n"
-			"Use -DPDCURSESDIR=DIR to specify the curses directory tree.\n")
-	endif(PDCURSES_FOUND)
-else(WIN32 AND NOT CYGWIN)
-	# Ncurses MANDATORY
+if (NOT WIN32)
+	# Ncurses MANDATORY for readline on POSIX
 	# -DNCURSESDIR=DIR
 	set(CMAKE_PREFIX_PATH ${NCURSESDIR})	
 	set(CURSES_NEED_NCURSES TRUE)
@@ -217,18 +203,20 @@
 				"(suitable Debian/Ubuntu package: libncurses-dev)\n")
 		endif(CURSES_FOUND)
 	endif(CURSES_FOUND)
-endif(WIN32 AND NOT CYGWIN)
+endif (NOT WIN32)
 
 # Readline
 # -DREADLINE=ON|OFF
 # -DREADLINEDIR=DIR
 if(READLINE)
-	# readline needs (n)curses
 	set(CMAKE_PREFIX_PATH ${READLINEDIR})
 	find_package(Readline QUIET)
 	set(HAVE_LIBREADLINE ${READLINE_FOUND})
 	if(READLINE_FOUND)
-		set(CMAKE_REQUIRED_LIBRARIES ${CURSES_LIBRARIES})
+    if(NOT WIN32)
+     	# readline needs (n)curses (not on Windows)
+ 		  set(CMAKE_REQUIRED_LIBRARIES ${CURSES_LIBRARIES})
+    endif(NOT WIN32)
 		check_library_exists("${READLINE_LIBRARIES}" rl_get_screen_size "" RL_GET_SCREEN_SIZE)
 		if(NOT RL_GET_SCREEN_SIZE)
 			message(STATUS "WARNING: Older GNU readline without rl_get_screen_size was found.\n"
@@ -287,11 +275,13 @@
 	find_package(OpenMP QUIET)
 	if(OPENMP_FOUND)
 		add_definitions(${OpenMP_CXX_FLAGS})
-		if(WIN32 AND NOT CYGWIN)
+		if(MSVC)
 			set(LIBRARIES ${LIBRARIES} vcomp)
-		else(WIN32 AND NOT CYGWIN)
+		elseif(WIN32)
+      set(LIBRARIES ${LIBRARIES} gomp pthread)
+    else()
 			set(LIBRARIES ${LIBRARIES} ${OpenMP_CXX_FLAGS})
-		endif(WIN32 AND NOT CYGWIN)
+		endif()
 	endif(OPENMP_FOUND)
 else(OPENMP)
   # we need to define those semaphore posix symbols, do it with threads libs
@@ -345,3 +335,18 @@
 else(PCRE_FOUND)
 	message(FATAL_ERROR "pcre library is required but was not found.\n"
 	"Use -DPCREDIR=DIR to specify the pcre directory tree.")
+endif(PCRE_FOUND)
+LINK_LIBRARIES(shlwapi)
+endif(WIN32 AND NOT CYGWIN)
+
+# PLplot MANDATORY
+# -DOLDPLPLOT=ON|OFF
+# -DPLPLOTDIR=DIR
+set(HAVE_OLDPLPLOT ${OLDPLPLOT})
+set(CMAKE_PREFIX_PATH ${PLPLOTDIR})
+find_package(Plplot QUIET)
+set(HAVE_LIBPLPLOTCXXD ${PLPLOT_FOUND})
+if(PLPLOT_FOUND)
+	set(LIBRARIES ${LIBRARIES} ${PLPLOT_LIBRARIES})
+	include_directories(${PLPLOT_INCLUDE_DIR})
+else(PLPLOT_FOUND)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -63,6 +63,8 @@
 devicesvg.hpp
 devicez.hpp
 dimension.hpp
+dialog.cpp
+dialog.hpp
 dinterpreter.cpp
 dinterpreter.hpp
 dnode.cpp
@@ -130,7 +132,6 @@
 gdlwidget.cpp
 gdlwidgeteventhandler.cpp
 gdlwidget.hpp
-gdlwidgetdraw.cpp
 gdlwxstream.cpp
 gdlwxstream.hpp
 gdlzstream.cpp
@@ -169,6 +170,8 @@
 io.cpp
 io.hpp
 lapack.cpp
+least_squares.cpp
+least_squares.hpp
 libinit.cpp
 libinit_ac.cpp
 libinit_cl.cpp
@@ -176,6 +179,7 @@
 libinit_jmg.cpp
 libinit_mes.cpp
 libinit_ng.cpp
+libinit_jp.cpp
 list.cpp
 list.hpp
 magick_cl.cpp
@@ -246,8 +250,8 @@
 semshm.hpp
 sigfpehandler.cpp
 sigfpehandler.hpp
-smooth.cpp
-smooth.hpp
+#smooth.cpp
+#smooth.hpp
 specializations.hpp
 str.cpp
 str.hpp

=== debian/changelog ===
gnudatalanguage (0.9.6v2-1build1) xenial; urgency=medium

  * No-change rebuild for netcdf transition.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 28 Jan 2016 22:07:52 +0000

gnudatalanguage (0.9.6v2-1) unstable; urgency=medium

  [ Axel Beckert ]
  * New upstream tar ball with partially re-added documentation.
    + Drop debian/gdl.1 and reactivate installation of upstream man pages.
    + Use patch against doc/gdl.1 instead of direct changes to
      debian/gdl.1.
  * Remove b-d on chrpath which is no more needed since 0.9.6-1.
  * Update watch file to also recognize short .tgz suffixes and xz
    compression.

  [ Ole Streicher ]
  * Fix includes for antlr instead of removing antlr subdir in d/rules
  * Build-depend on python-dev instead of python-all-dev: we currently
    build only for the most recent Python 2.x version and not for all.
  * Use default settings for Python library search; the multiarch patch
    is not needed anymore.

 -- Axel Beckert <abe@debian.org>  Mon, 11 Jan 2016 20:53:52 +0100

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,7 @@
            Ole Streicher <olebole@debian.org>
 Section: interpreters
 Priority: extra
-Build-Depends: chrpath,
-               cmake,
+Build-Depends: cmake,
                debhelper (>= 9~),
                dpkg-dev (>= 1.16.1~),
                libantlr-dev,
@@ -25,7 +24,7 @@
                libwxgtk3.0-dev,
                plplot12-driver-xwin,
                pslib-dev,
-               python-all-dev,
+               python-dev,
                python-numpy,
                xauth,
                xvfb,

=== debian/rules ===
--- 
+++ 
@@ -7,13 +7,7 @@
 	dh $@ --parallel -Scmake
 
 override_dh_auto_configure:
-	# Patched source FTBFS if this embedded code copy is present
-	tar cf antlr.tar src/antlr
-	rm -rf src/antlr
-
 	dh_auto_configure -- \
-	  -DPYTHONDIR=/usr \
-	  -DPYTHONVERSION=2.7 \
 	  -DDEB_BUILD_MULTIARCH=`dpkg-architecture -qDEB_BUILD_MULTIARCH` \
 	  -DFFTW=YES \
 	  -DPYTHON=YES \
@@ -30,11 +24,6 @@
 	&& $(CC) -o launchtest ../../testsuite/launchtest.c )
 	LD_LIBRARY_PATH="../src" xvfb-run dh_auto_test --no-parallel -Scmake || true
 
-override_dh_auto_clean:
-	if [ -f  antlr.tar ]; then tar xf antlr.tar; fi
-	rm -f antlr.tar
-	dh_auto_clean --parallel
-
 override_dh_compress:
 	dh_compress -X.pro

=== debian/tests/control ===
Tests: test-gdl
Depends: gnudatalanguage, xauth, xvfb, plplot12-driver-xwin

Tests: test-GDL.py
Depends: python-gdl, python-pytest
